#!/usr/bin/perl -w
#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: client.cgi,v 1.15 2004/02/01 09:20:05 fuktommy Exp $
#

use lib qw(..);
use Shingetsu::Config;
use Shingetsu::Node;
use Shingetsu::NodeList;
use Shingetsu::Cache;
use Shingetsu::CacheStat;
use Shingetsu::Util;

umask $Shingetsu::Config::umask;
$SIG{ALRM} = sub { die };
alarm $Shingetsu::Config::timeout_client * 60;
print "Content-type: text/plain\n",
      "X-Shingetsu: shinGETsu/$Shingetsu::Config::version\n\n";

%time = ();
if ($ENV{REMOTE_ADDR} !~ $Shingetsu::Config::adminAddr) {
	print "You are not the administrator.\n";
	exit;
} elsif (open IN, $Shingetsu::Config::client) {
	$time{ping} = <IN>;
	$time{sync} = <IN>;
	$time{init} = <IN>;
	chomp($time{ping}, $time{sync}, $time{init});
	close IN;
} else {
	($time{ping}, $time{sync}, $time{init}) = (0, 0, 0);
}

Shingetsu::Cache::newFiles();

if ((time - $time{ping}) >= $Shingetsu::Config::pingfrec * 60) {
	$time{ping} = time;
	save(%time);
	Shingetsu::NodeList::pingall();
	print "PING\n";
}

@node = Shingetsu::NodeList::all();
if (@node == 0) {
	$time{init} = time;
	save(%time);
	Shingetsu::NodeList::init();
	print "INIT\n";

	$time{sync} = time;
	save(%time);
	Shingetsu::CacheStat::update();
	Shingetsu::Cache::sync();
	print "SYNC\n";
}

$nc = Shingetsu::NodeList::count();
if ((time - $time{init}) >= $Shingetsu::Config::initfrec * $nc * 60) {
	$time{init} = time;
	save(%time);
	Shingetsu::NodeList::init();
	print "INIT\n";
}

if ((time - $time{sync}) >= $Shingetsu::Config::syncfrec * 60) {
	foreach (@node) {
		my $n = $_->toString();
		Shingetsu::NodeList::join($_);
	}
	$time{sync} = time;
	save(%time);
	Shingetsu::CacheStat::update();
	Shingetsu::Cache::sync();
	print "SYNC\n";
}

#
# save status
#
sub save {
	my(%time) = @_;
	local $, = "\n";
	Shingetsu::Util::lock();
	open OUT, "> $Shingetsu::Config::client"
		or die "Failed to open $Shingetsu::Config::client. $!";
	print OUT $time{ping}, $time{sync}, $time{init}, "";
	close OUT;
	Shingetsu::Util::unlock();
}
